include \masm32\include\masm32rt.inc
.686
include timers.asm

include ..\lalist.inc
includelib ..\lalist.lib

debug macro args:vararg
	pushad
	% print args
	popad
endm

.code
start:
	
	call laCreate
	mov edi, eax
	
	mov esi, 0
	counter_begin 1000000, HIGH_PRIORITY_CLASS
	add esi, 1
	push esi
	push edi
	call laAdd
	counter_end
	debug "Add: "
	debug <ustr$(eax)>, 10
	
	push edi
	call laIterateStart
	mov esi, eax
	
	; iterate
	counter_begin 1000000, HIGH_PRIORITY_CLASS
	push esi
	call laIterateNext
	counter_end
	debug "Iterate: "
	debug <ustr$(eax)>, 10
	
	push esi
	call laIterateEnd
	
	push edi
	call laIterateStart
	mov esi, eax
	
	; remove all
	counter_begin 1000000, HIGH_PRIORITY_CLASS
	push esi
	call laIterateNext
	push esi
	call laIterateRemove
	counter_end
	debug "Iterate + remove: "
	debug <ustr$(eax)>, 10
	
	push ebx
	call laIterateEnd
	
	push edi
	call laDestroy
	
	inkey
	
	exit

end start